import It from "css-tree/parser";
import q from "css-tree/walker";
import { calculateForAST as Ut } from "@bramus/specificity/core";
function Fe(i, t) {
  return t >= 65 && t <= 90 && (t = t | 32), i === t;
}
function z(i, t) {
  if (i === t) return !0;
  let r = i.length;
  if (r !== t.length) return !1;
  for (let e = 0; e < r; e++)
    if (Fe(i.charCodeAt(e), t.charCodeAt(e)) === !1)
      return !1;
  return !0;
}
function L(i, t) {
  if (i === t) return !0;
  let r = t.length, e = r - i.length;
  if (e < 0)
    return !1;
  for (let l = r - 1; l >= e; l--)
    if (Fe(i.charCodeAt(l - e), t.charCodeAt(l)) === !1)
      return !1;
  return !0;
}
function Te(i, t) {
  if (i === t) return !0;
  let r = i.length;
  if (t.length < r) return !1;
  for (let e = 0; e < r; e++)
    if (Fe(i.charCodeAt(e), t.charCodeAt(e)) === !1)
      return !1;
  return !0;
}
const Ht = "Atrule", Vt = "MediaQuery", Wt = "Rule", Me = "Selector", At = "TypeSelector", G = "PseudoClassSelector", Pt = "AttributeSelector", Lt = "PseudoElementSelector", De = "Declaration", Kt = "Value", O = "Identifier", jt = "Nth", Bt = "Combinator", Yt = "Number", Ot = "Dimension", V = "Operator", Gt = "Hash", Qt = "Url", Ie = "Function";
function _t(i, t, r) {
  let e = i.value.children.first;
  return z(t, i.property) && e.type === O && z(r, e.name);
}
function Nt(i) {
  let t = !1;
  return q(i, function(r) {
    if (r.type === De && (_t(r, "-webkit-appearance", "none") || _t(r, "-moz-appearance", "meterbar")))
      return t = !0, this.break;
  }), t;
}
function Zt(i) {
  let t = !1;
  return q(i, function(r) {
    let e = r.name, l = r.value;
    if (r.type === Vt && r.mediaType !== null) {
      if (Te("\\0", r.mediaType) || L("\\9 ", r.mediaType))
        return t = !0, this.break;
    } else if (r.type === "Feature" && r.kind === "media") {
      if (l && l.unit && l.unit === "\\0")
        return t = !0, this.break;
      if (z("-moz-images-in-menus", e) || z("min--moz-device-pixel-ratio", e) || z("-ms-high-contrast", e))
        return t = !0, this.break;
      if (z("min-resolution", e) && l && z(".001", l.value) && z("dpcm", l.unit))
        return t = !0, this.break;
      if (z("-webkit-min-device-pixel-ratio", e) && l && l.value && (z("0", l.value) || z("10000", l.value)))
        return t = !0, this.break;
    }
  }), t;
}
const St = 45;
function D(i) {
  return i.charCodeAt(0) === St && i.charCodeAt(1) !== St && i.indexOf("-", 2) !== -1;
}
class A {
  /** @param {string[]} items */
  constructor(t) {
    this.set = new Set(t);
  }
  /** @param {string} item */
  has(t) {
    return this.set.has(t.toLowerCase());
  }
}
function Rt(i, t) {
  let r = [];
  return q(i, {
    visit: Me,
    enter: function(e) {
      r.push(t(e));
    }
  }), r;
}
const Et = new A([
  "nth-child",
  "where",
  "not",
  "is",
  "has",
  "nth-last-child",
  "matches",
  "-webkit-any",
  "-moz-any"
]);
function Dt(i) {
  let t = !1;
  return q(i, function(r) {
    if (r.type === Pt) {
      let e = r.name.name;
      if (z("role", e) || Te("aria-", e))
        return t = !0, this.break;
    } else if (r.type === G && Et.has(r.name)) {
      let e = Rt(r, Dt);
      for (let l of e)
        if (l === !0) {
          t = !0;
          break;
        }
      return this.skip;
    }
  }), t;
}
function Jt(i) {
  let t = !1;
  return q(i, function(r) {
    let e = r.type;
    if ((e === Lt || e === At || e === G) && D(r.name))
      return t = !0, this.break;
  }), t;
}
function Xt(i) {
  let t = [];
  return q(i, function(r) {
    r.type === G && t.push(r.name);
  }), t.length === 0 ? !1 : t;
}
function Ft(i) {
  let t = 0;
  return q(i, function(r) {
    let e = r.type;
    if (!(e === Me || e === jt)) {
      if (t++, (e === Lt || e === At || e === G) && D(r.name) && t++, e === Pt)
        return r.value && t++, this.skip;
      if (e === G && Et.has(r.name)) {
        let l = Rt(r, Ft);
        if (l.length === 0) return;
        for (let n of l)
          t += n;
        return this.skip;
      }
    }
  }), t;
}
function $t(i, t) {
  q(i, function(r, e) {
    if (r.type === Bt) {
      let l = r.loc, n = r.name;
      if (l === null) {
        let g = e.prev.data.loc.end, w = {
          offset: g.offset,
          line: g.line,
          column: g.column
        };
        t({
          name: n,
          loc: {
            start: w,
            end: {
              offset: w.offset + 1,
              line: w.line,
              column: w.column + 1
            }
          }
        });
      } else
        t({
          name: n,
          loc: l
        });
    }
  });
}
const ei = new A([
  // CSS Named Colors
  // Spec: https://drafts.csswg.org/css-color/#named-colors
  // Heuristic: popular names first for quick finding in set.has()
  // See: https://docs.google.com/spreadsheets/d/1OU8ahxC5oYU8VRryQs9BzHToaXcOntVlh6KUHjm15G4/edit#gid=2096495459
  "white",
  "black",
  "red",
  "gray",
  "silver",
  "grey",
  "green",
  "orange",
  "blue",
  "dimgray",
  "whitesmoke",
  "lightgray",
  "lightgrey",
  "yellow",
  "gold",
  "pink",
  "gainsboro",
  "magenta",
  "purple",
  "darkgray",
  "navy",
  "darkred",
  "teal",
  "maroon",
  "darkgrey",
  "tomato",
  "darkorange",
  "brown",
  "crimson",
  "lightyellow",
  "slategray",
  "salmon",
  "lightgreen",
  "lightblue",
  "orangered",
  "aliceblue",
  "dodgerblue",
  "lime",
  "darkblue",
  "darkgoldenrod",
  "skyblue",
  "royalblue",
  "darkgreen",
  "ivory",
  "olive",
  "aqua",
  "turquoise",
  "cyan",
  "khaki",
  "beige",
  "snow",
  "ghostwhite",
  "limegreen",
  "coral",
  "dimgrey",
  "hotpink",
  "midnightblue",
  "firebrick",
  "indigo",
  "wheat",
  "mediumblue",
  "lightpink",
  "plum",
  "azure",
  "violet",
  "lavender",
  "deepskyblue",
  "darkslategrey",
  "goldenrod",
  "cornflowerblue",
  "lightskyblue",
  "indianred",
  "yellowgreen",
  "saddlebrown",
  "palegreen",
  "bisque",
  "tan",
  "antiquewhite",
  "steelblue",
  "forestgreen",
  "fuchsia",
  "mediumaquamarine",
  "seagreen",
  "sienna",
  "deeppink",
  "mediumseagreen",
  "peru",
  "greenyellow",
  "lightgoldenrodyellow",
  "orchid",
  "cadetblue",
  "navajowhite",
  "lightsteelblue",
  "slategrey",
  "linen",
  "lightseagreen",
  "darkcyan",
  "lightcoral",
  "aquamarine",
  "blueviolet",
  "cornsilk",
  "lightsalmon",
  "chocolate",
  "lightslategray",
  "floralwhite",
  "darkturquoise",
  "darkslategray",
  "rebeccapurple",
  "burlywood",
  "chartreuse",
  "lightcyan",
  "lemonchiffon",
  "palevioletred",
  "darkslateblue",
  "mediumpurple",
  "lawngreen",
  "slateblue",
  "darkseagreen",
  "blanchedalmond",
  "mistyrose",
  "darkolivegreen",
  "seashell",
  "olivedrab",
  "peachpuff",
  "darkviolet",
  "powderblue",
  "darkmagenta",
  "lightslategrey",
  "honeydew",
  "palegoldenrod",
  "darkkhaki",
  "oldlace",
  "mintcream",
  "sandybrown",
  "mediumturquoise",
  "papayawhip",
  "paleturquoise",
  "mediumvioletred",
  "thistle",
  "springgreen",
  "moccasin",
  "rosybrown",
  "lavenderblush",
  "mediumslateblue",
  "darkorchid",
  "mediumorchid",
  "darksalmon",
  "mediumspringgreen"
]), ti = new A([
  // CSS System Colors
  // Spec: https://drafts.csswg.org/css-color/#css-system-colors
  "accentcolor",
  "accentcolortext",
  "activetext",
  "buttonborder",
  "buttonface",
  "buttontext",
  "canvas",
  "canvastext",
  "field",
  "fieldtext",
  "graytext",
  "highlight",
  "highlighttext",
  "linktext",
  "mark",
  "marktext",
  "selecteditem",
  "selecteditemtext",
  "visitedtext"
]), ii = new A([
  "rgba",
  "rgb",
  "hsla",
  "hsl",
  "oklch",
  "color",
  "hwb",
  "lch",
  "lab",
  "oklab"
]), ri = new A([
  "transparent",
  "currentcolor"
]), te = new A([
  "auto",
  "none",
  // for `text-shadow`, `box-shadow` and `background`
  "inherit",
  "initial",
  "unset",
  "revert",
  "revert-layer"
]);
function ee(i) {
  let t = i.children, r = t.size;
  if (!t || r > 1 || r === 0) return !1;
  let e = t.first;
  return e.type === O && te.has(e.name);
}
const si = new A([
  "caption",
  "icon",
  "menu",
  "message-box",
  "small-caption",
  "status-bar"
]), li = new A([
  /* <absolute-size> values */
  "xx-small",
  "x-small",
  "small",
  "medium",
  "large",
  "x-large",
  "xx-large",
  "xxx-large",
  /* <relative-size> values */
  "smaller",
  "larger"
]), ni = 44, vt = 47;
function Re(i) {
  let t = i.children.first;
  return t === null ? !1 : t.type === O && si.has(t.name);
}
function ai(i, t, r) {
  var w;
  let e = Array.from({ length: 2 }), l, n;
  i.children.forEach(function(d, _) {
    let y = _.prev ? _.prev.data : void 0, P = _.next ? _.next.data : void 0;
    if (d.type === O && te.has(d.name) && r({
      type: "keyword",
      value: d.name
    }), P && P.type === V && P.value.charCodeAt(0) === vt) {
      l = t(d);
      return;
    }
    if (y && y.type === V && y.value.charCodeAt(0) === vt) {
      n = t(d);
      return;
    }
    if (P && P.type === V && P.value.charCodeAt(0) === ni && !e[0]) {
      e[0] = d, !l && y && (l = t(y));
      return;
    }
    if (d.type !== Yt) {
      if (_.next === null) {
        e[1] = d, !l && !e[0] && y && (l = t(y));
        return;
      }
      if (d.type === O) {
        let R = d.name;
        if (li.has(R)) {
          l = R;
          return;
        }
      }
    }
  });
  let g = e[0] || e[1] ? t({
    loc: {
      start: {
        offset: (e[0] || e[1]).loc.start.offset
      },
      end: {
        // Either the node we detected as the last node, or the end of the whole value
        // It's never 0 because the first node is always a font-size or font-style
        offset: ((w = e[1]) == null ? void 0 : w.loc.end.offset) || i.loc.end.offset
      }
    }
  }) : null;
  return {
    font_size: l,
    line_height: n,
    font_family: g
  };
}
const oi = new A([
  "linear",
  "ease",
  "ease-in",
  "ease-out",
  "ease-in-out",
  "step-start",
  "step-end"
]), ui = new A([
  "cubic-bezier",
  "steps"
]);
function ci(i, t) {
  let r = !1;
  for (let e of i) {
    let l = e.type, n = e.name;
    l === V ? r = !1 : l === Ot && r === !1 ? (r = !0, t({
      type: "duration",
      value: e
    })) : l === O ? oi.has(n) ? t({
      type: "fn",
      value: e
    }) : te.has(n) && t({
      type: "keyword",
      value: e
    }) : l === Ie && ui.has(n) && t({
      type: "fn",
      value: e
    });
  }
}
function Tt(i) {
  let t = i.children;
  if (!t)
    return !1;
  for (let r of t) {
    let { type: e, name: l } = r;
    if (e === O && D(l) || e === Ie && (D(l) || Tt(r)))
      return !0;
  }
  return !1;
}
class u {
  /** @param {boolean} useLocations */
  constructor(t = !1) {
    this._items = /* @__PURE__ */ new Map(), this._total = 0, t && (this._nodes = []), this._useLocations = t;
  }
  /**
   * @param {string | number} item
   * @param {import('css-tree').CssLocation} node_location
   */
  p(t, r) {
    let e = this._total;
    if (this._useLocations) {
      let l = r.start, n = l.offset, g = e * 4;
      this._nodes[g] = l.line, this._nodes[g + 1] = l.column, this._nodes[g + 2] = n, this._nodes[g + 3] = r.end.offset - n;
    }
    if (this._items.has(t)) {
      this._items.get(t).push(e), this._total++;
      return;
    }
    this._items.set(t, [e]), this._total++;
  }
  size() {
    return this._total;
  }
  /**
   * @typedef CssLocation
   * @property {number} line
   * @property {number} column
   * @property {number} offset
   * @property {number} length
   *
   * @returns {{
   * 	total: number;
   * 	totalUnique: number;
   * 	uniquenessRatio: number;
   * 	unique: Record<string, number>;
   * } & ({
   * 	uniqueWithLocations: Record<string, CssLocation[]>
   * } | {
   * 	uniqueWithLocations?: undefined
   * })}
   */
  c() {
    let t = /* @__PURE__ */ new Map(), r = {}, e = this._useLocations, l = this._items, n = this._nodes, g = l.size;
    l.forEach((_, y) => {
      if (e) {
        let P = _.map(function(R) {
          let F = R * 4;
          return {
            line: n[F],
            column: n[F + 1],
            offset: n[F + 2],
            length: n[F + 3]
          };
        });
        t.set(y, P);
      } else
        r[y] = _.length;
    });
    let w = this._total, d = {
      total: w,
      totalUnique: g,
      unique: r,
      uniquenessRatio: w === 0 ? 0 : g / w
    };
    return e && (d.uniqueWithLocations = Object.fromEntries(t)), d;
  }
}
class Ee {
  /** @param {boolean} useLocations */
  constructor(t) {
    this._list = new u(t), this._contexts = /* @__PURE__ */ new Map(), this._useLocations = t;
  }
  /**
   * Add an item to this _list's context
   * @param {string} item Item to push
   * @param {string} context Context to push Item to
   * @param {import('css-tree').CssLocation} node_location
   */
  push(t, r, e) {
    this._list.p(t, e), this._contexts.has(r) || this._contexts.set(r, new u(this._useLocations)), this._contexts.get(r).p(t, e);
  }
  count() {
    let t = /* @__PURE__ */ new Map();
    for (let [r, e] of this._contexts.entries())
      t.set(r, e.c());
    return Object.assign(this._list.c(), {
      itemsPerContext: Object.fromEntries(t)
    });
  }
}
function fi(i) {
  let t = /* @__PURE__ */ new Map(), r = -1, e = 0, l = 0, n = i.length;
  for (let g = 0; g < n; g++) {
    let w = i[g], d = (t.get(w) || 0) + 1;
    t.set(w, d), d > r && (r = d, e = 0, l = 0), d >= r && (e++, l += w);
  }
  return l / e;
}
class v {
  constructor() {
    this._items = [], this._sum = 0;
  }
  /**
   * Add a new Integer at the end of this AggregateCollection
   * @param {number} item - The item to add
   */
  push(t) {
    this._items.push(t), this._sum += t;
  }
  size() {
    return this._items.length;
  }
  aggregate() {
    let t = this._items.length;
    if (t === 0)
      return {
        min: 0,
        max: 0,
        mean: 0,
        mode: 0,
        range: 0,
        sum: 0
      };
    let r = this._items.slice().sort((w, d) => w - d), e = r[0], l = r[t - 1], n = fi(r), g = this._sum;
    return {
      min: e,
      max: l,
      mean: g / t,
      mode: n,
      range: l - e,
      sum: g
    };
  }
  /**
   * @returns {number[]} All _items in this collection
   */
  toArray() {
    return this._items;
  }
}
function pi(i) {
  if (Ue(i) || D(i)) return !1;
  let t = i.charCodeAt(0);
  return t === 47 || t === 42 || t === 95 || t === 43 || t === 38 || t === 36 || t === 35;
}
function Ue(i) {
  return i.length < 3 ? !1 : i.charCodeAt(0) === 45 && i.charCodeAt(1) === 45;
}
function x(i, t) {
  return Ue(t) ? !1 : L(i, t);
}
function hi(i) {
  return D(i) ? i.slice(i.indexOf("-", 2) + 1) : i;
}
function mi(i) {
  let t = 5, r = i.indexOf(";"), e = i.indexOf(",");
  return r === -1 || e !== -1 && e < r ? i.substring(t, e) : i.substring(t, r);
}
function gi(i) {
  let t = i.children;
  if (t) {
    let r = t.last;
    return r && r.type === O && L("\\9", r.name);
  }
  return !1;
}
let di = new A([
  "border-radius",
  "border-top-left-radius",
  "border-top-right-radius",
  "border-bottom-right-radius",
  "border-bottom-left-radius",
  "border-start-start-radius",
  "border-start-end-radius",
  "border-end-end-radius",
  "border-end-start-radius"
]);
function C(i, t) {
  return t === 0 ? 0 : i / t;
}
let yi = {
  useLocations: !1
};
function xi(i, t = {}) {
  let e = Object.assign({}, yi, t).useLocations === !0, l = Date.now();
  function n(s) {
    return g(s).trim();
  }
  function g(s) {
    let Y = s.loc;
    return i.substring(Y.start.offset, Y.end.offset);
  }
  let w = 0, d = 0, _ = 0, y = {
    total: 0,
    /** @type {Map<string, { size: number, count: number } & ({ uniqueWithLocations?: undefined } | ({ uniqueWithLocations: { offset: number, line: number, column: number, length: number }[] })) }>} */
    unique: /* @__PURE__ */ new Map()
  }, P = Date.now(), R = It(i, {
    parseCustomProperty: !0,
    // To find font-families, colors, etc.
    positions: !0,
    // So we can use stringifyNode()
    /** @param {string} comment */
    onComment: function(s) {
      w++, d += s.length;
    }
  }), F = Date.now(), Mt = R.loc.end.line - R.loc.start.line + 1, ie = 0, re = new v(), se = [], He = new u(e), le = new u(e), Ve = new u(e), We = new u(e), Ke = new u(e), je = new u(e), Be = new u(e), ne = new u(e), Ye = new u(e), ae = new u(e), oe = new u(e), Ge = new u(e), Q = new u(e), Qe = new u(e), ue = 0, ce = 0, fe = new v(), pe = new v(), he = new v(), Ne = new u(e), Ze = new u(e), Je = new u(e), me = new u(e), Xe = /* @__PURE__ */ new Set(), ge = new u(e), T, M, $e = new v(), et = new v(), tt = new v(), it = new u(e), N = new v(), rt = new u(e), st = [], de = new u(e), ye = new u(e), lt = new u(e), nt = new u(e), at = /* @__PURE__ */ new Set(), W = 0, ot = new v(), Z = 0, we = 0, ke = new u(e), K = new u(e), be = new u(e), xe = new u(e), J = new u(e), j = new v(), Ce = new v(), ut = new u(e), ze = new u(e), ct = new u(e), ft = new u(e), pt = new u(e), _e = new u(e), Se = new u(e), ve = new u(e), X = new u(e), $ = new u(e), I = new Ee(e), U = new u(e), qe = new Ee(e), ht = new u(e), B = new u(e), mt = new Ee(e);
  q(R, function(s) {
    var Y, zt;
    switch (s.type) {
      case Ht: {
        ie++;
        let p = s.name;
        if (p === "font-face") {
          let m = {};
          e && He.p(s.loc.start.offset, s.loc), s.block.children.forEach((c) => {
            c.type === De && (m[c.property] = n(c.value));
          }), se.push(m), re.push(1);
          break;
        }
        let a = 1;
        if (s.prelude !== null) {
          let m = s.prelude, c = m && n(s.prelude), f = m.loc;
          if (p === "media")
            We.p(c, f), Zt(m) && (Ke.p(c, f), a++);
          else if (p === "supports")
            ne.p(c, f), Nt(m) && (Ye.p(c, f), a++);
          else if (L("keyframes", p)) {
            let o = "@" + p + " " + c;
            D(p) && (oe.p(o, f), a++), ae.p(o, f);
          } else if (p === "import")
            q(s, function(o) {
              if (o.type === "Condition" && o.kind === "supports") {
                let h = n(o);
                return ne.p(h, o.loc), this.break;
              }
            }), Ve.p(c, f);
          else if (p === "charset")
            Be.p(c, f);
          else if (p === "container") {
            if (Ge.p(c, f), ((Y = m.children.first) == null ? void 0 : Y.type) === "Identifier") {
              let o = m.children.first.name;
              console.log(o), Q.p(o, f);
            }
          } else p === "property" && Qe.p(c, f);
        } else
          p === "layer" && (le.p("<anonymous>", s.loc), a++);
        re.push(a);
        break;
      }
      case "Layer": {
        s.name !== null && le.p(s.name, s.loc);
        break;
      }
      case "Feature": {
        je.p(s.name, s.loc);
        break;
      }
      case Wt: {
        let p = s.prelude, a = s.block, m = p.children, c = a.children, f = m ? m.size : 0, o = c ? c.size : 0;
        fe.push(f + o), Ne.p(f + o, s.loc), pe.push(f), Ze.p(f, p.loc), he.push(o), Je.p(o, a.loc), ue++, o === 0 && ce++;
        break;
      }
      case Me: {
        let p = n(s);
        if (this.atrule && L("keyframes", this.atrule.name))
          return me.p(p, s.loc), this.skip;
        Dt(s) && ye.p(p, s.loc);
        let a = Xt(s);
        if (a !== !1)
          for (let b of a)
            lt.p(b, s.loc);
        let m = Ft(s);
        Jt(s) && ge.p(p, s.loc), Xe.add(p), N.push(m), rt.p(m, s.loc);
        let c = Ut(s).toArray(), [f, o, h] = c;
        return it.p(c.toString(), s.loc), $e.push(f), et.push(o), tt.push(h), T === void 0 && (T = c), M === void 0 && (M = c), M !== void 0 && qt(M, c) < 0 && (M = c), T !== void 0 && qt(T, c) > 0 && (T = c), st.push(c), f > 0 && de.p(p, s.loc), $t(s, function(S) {
          nt.p(S.name, S.loc);
        }), this.skip;
      }
      case Ot: {
        if (!this.declaration)
          break;
        let p = s.unit;
        return L("\\9", p) ? qe.push(p.substring(0, p.length - 2), this.declaration.property, s.loc) : qe.push(p, this.declaration.property, s.loc), this.skip;
      }
      case Qt: {
        if (Te("data:", s.value)) {
          let p = s.value, a = p.length, m = mi(p);
          y.total++, _ += a;
          let c = {
            /** @type {number} */
            line: s.loc.start.line,
            /** @type {number} */
            column: s.loc.start.column,
            /** @type {number} */
            offset: s.loc.start.offset,
            /** @type {number} */
            length: s.loc.end.offset - s.loc.start.offset
          };
          if (y.unique.has(m)) {
            let f = y.unique.get(m);
            f.count++, f.size += a, y.unique.set(m, f), e && f.uniqueWithLocations.push(c);
          } else {
            let f = {
              count: 1,
              size: a
            };
            e && (f.uniqueWithLocations = [c]), y.unique.set(m, f);
          }
        }
        break;
      }
      case Kt: {
        if (ee(s)) {
          Ce.push(1), B.p(n(s), s.loc);
          break;
        }
        let p = this.declaration, { property: a, important: m } = p, c = 1;
        Tt(s) && (ut.p(n(s), s.loc), c++), typeof m == "string" && (ze.p(g(s) + "!" + m, s.loc), c++), gi(s) && (ze.p(n(s), s.loc), c++);
        let f = s.children, o = s.loc;
        if (Ce.push(c), x("z-index", a))
          return ct.p(n(s), o), this.skip;
        if (x("font", a)) {
          if (Re(s)) return;
          let { font_size: h, line_height: b, font_family: S } = ai(s, n, function(E) {
            E.type === "keyword" && B.p(E.value, o);
          });
          S && _e.p(S, o), h && Se.p(h, o), b && ve.p(b, o);
          break;
        } else if (x("font-size", a)) {
          Re(s) || Se.p(n(s), o);
          break;
        } else if (x("font-family", a)) {
          Re(s) || _e.p(n(s), o);
          break;
        } else if (x("line-height", a))
          ve.p(n(s), o);
        else if (x("transition", a) || x("animation", a)) {
          ci(f, function(h) {
            h.type === "fn" ? X.p(n(h.value), o) : h.type === "duration" ? $.p(n(h.value), o) : h.type === "keyword" && B.p(n(h.value), o);
          });
          break;
        } else if (x("animation-duration", a) || x("transition-duration", a)) {
          f && f.size > 1 ? f.forEach((h) => {
            h.type !== V && $.p(n(h), o);
          }) : $.p(n(s), o);
          break;
        } else if (x("transition-timing-function", a) || x("animation-timing-function", a)) {
          f && f.size > 1 ? f.forEach((h) => {
            h.type !== V && X.p(n(h), o);
          }) : X.p(n(s), o);
          break;
        } else if (x("container-name", a))
          Q.p(n(s), o);
        else if (x("container", a))
          ((zt = f.first) == null ? void 0 : zt.type) === "Identifier" && Q.p(f.first.name, o);
        else if (di.has(hi(a))) {
          ee(s) || mt.push(n(s), a, o);
          break;
        } else x("text-shadow", a) ? ee(s) || ft.p(n(s), o) : x("box-shadow", a) && (ee(s) || pt.p(n(s), o));
        q(s, function(h) {
          let b = h.name;
          switch (h.type) {
            case Gt: {
              let S = h.value.length;
              return L("\\9", h.value) && (S = S - 2), I.push("#" + h.value, a, o), U.p("hex" + S, o), this.skip;
            }
            case O: {
              te.has(b) && B.p(b, o);
              let S = b.length;
              if (S > 20 || S < 3)
                return this.skip;
              if (ri.has(b)) {
                let E = n(h);
                I.push(E, a, o), U.p(b.toLowerCase(), o);
                return;
              }
              if (ei.has(b)) {
                let E = n(h);
                I.push(E, a, o), U.p("named", o);
                return;
              }
              if (ti.has(b)) {
                let E = n(h);
                I.push(E, a, o), U.p("system", o);
                return;
              }
              return this.skip;
            }
            case Ie: {
              if (z("var", b))
                return this.skip;
              if (ii.has(b)) {
                I.push(n(h), a, h.loc), U.p(b.toLowerCase(), h.loc);
                return;
              }
              if (L("gradient", b)) {
                ht.p(n(h), h.loc);
                return;
              }
            }
          }
        });
        break;
      }
      case De: {
        if (this.atrulePrelude !== null)
          return this.skip;
        W++;
        let p = 1;
        at.add(n(s)), s.important === !0 && (Z++, p++, this.atrule && L("keyframes", this.atrule.name) && (we++, p++)), ot.push(p);
        let { property: a, loc: { start: m } } = s, c = {
          start: {
            line: m.line,
            column: m.column,
            offset: m.offset
          },
          end: {
            offset: m.offset + a.length
          }
        };
        K.p(a, c), D(a) ? (xe.p(a, c), j.push(2)) : pi(a) ? (be.p(a, c), j.push(2)) : Ue(a) ? (J.p(a, c), j.push(s.important ? 3 : 2), s.important === !0 && ke.p(a, c)) : j.push(1);
        break;
      }
    }
  });
  let gt = at.size, H = N.size(), Ae = $e.aggregate(), Pe = et.aggregate(), Le = tt.aggregate(), dt = Xe.size, k = Object.assign, yt = i.length, Oe = se.length, wt = re.aggregate(), kt = N.aggregate(), bt = ot.aggregate(), xt = j.aggregate(), Ct = Ce.aggregate();
  return {
    stylesheet: {
      sourceLinesOfCode: ie + H + W + me.size(),
      linesOfCode: Mt,
      size: yt,
      complexity: wt.sum + kt.sum + bt.sum + xt.sum + Ct.sum,
      comments: {
        total: w,
        size: d
      },
      embeddedContent: {
        size: {
          total: _,
          ratio: C(_, yt)
        },
        types: {
          total: y.total,
          totalUnique: y.unique.size,
          uniquenessRatio: C(y.unique.size, y.total),
          unique: Object.fromEntries(y.unique)
        }
      }
    },
    atrules: {
      fontface: k({
        total: Oe,
        totalUnique: Oe,
        unique: se,
        uniquenessRatio: Oe === 0 ? 0 : 1
      }, e ? {
        uniqueWithLocations: He.c().uniqueWithLocations
      } : {}),
      import: Ve.c(),
      media: k(
        We.c(),
        {
          browserhacks: Ke.c(),
          features: je.c()
        }
      ),
      charset: Be.c(),
      supports: k(
        ne.c(),
        {
          browserhacks: Ye.c()
        }
      ),
      keyframes: k(
        ae.c(),
        {
          prefixed: k(
            oe.c(),
            {
              ratio: C(oe.size(), ae.size())
            }
          )
        }
      ),
      container: k(
        Ge.c(),
        {
          names: Q.c()
        }
      ),
      layer: le.c(),
      property: Qe.c(),
      total: ie,
      complexity: wt
    },
    rules: {
      total: ue,
      empty: {
        total: ce,
        ratio: C(ce, ue)
      },
      sizes: k(
        fe.aggregate(),
        {
          items: fe.toArray()
        },
        Ne.c()
      ),
      selectors: k(
        pe.aggregate(),
        {
          items: pe.toArray()
        },
        Ze.c()
      ),
      declarations: k(
        he.aggregate(),
        {
          items: he.toArray()
        },
        Je.c()
      )
    },
    selectors: {
      total: H,
      totalUnique: dt,
      uniquenessRatio: C(dt, H),
      specificity: k(
        {
          /** @type Specificity */
          min: M === void 0 ? [0, 0, 0] : M,
          /** @type Specificity */
          max: T === void 0 ? [0, 0, 0] : T,
          /** @type Specificity */
          sum: [Ae.sum, Pe.sum, Le.sum],
          /** @type Specificity */
          mean: [Ae.mean, Pe.mean, Le.mean],
          /** @type Specificity */
          mode: [Ae.mode, Pe.mode, Le.mode],
          /** @type Specificity */
          items: st
        },
        it.c()
      ),
      complexity: k(
        kt,
        rt.c(),
        {
          items: N.toArray()
        }
      ),
      id: k(
        de.c(),
        {
          ratio: C(de.size(), H)
        }
      ),
      pseudoClasses: lt.c(),
      accessibility: k(
        ye.c(),
        {
          ratio: C(ye.size(), H)
        }
      ),
      keyframes: me.c(),
      prefixed: k(
        ge.c(),
        {
          ratio: C(ge.size(), H)
        }
      ),
      combinators: nt.c()
    },
    declarations: {
      total: W,
      totalUnique: gt,
      uniquenessRatio: C(gt, W),
      importants: {
        total: Z,
        ratio: C(Z, W),
        inKeyframes: {
          total: we,
          ratio: C(we, Z)
        }
      },
      complexity: bt
    },
    properties: k(
      K.c(),
      {
        prefixed: k(
          xe.c(),
          {
            ratio: C(xe.size(), K.size())
          }
        ),
        custom: k(
          J.c(),
          {
            ratio: C(J.size(), K.size()),
            importants: k(
              ke.c(),
              {
                ratio: C(ke.size(), J.size())
              }
            )
          }
        ),
        browserhacks: k(
          be.c(),
          {
            ratio: C(be.size(), K.size())
          }
        ),
        complexity: xt
      }
    ),
    values: {
      colors: k(
        I.count(),
        {
          formats: U.c()
        }
      ),
      gradients: ht.c(),
      fontFamilies: _e.c(),
      fontSizes: Se.c(),
      lineHeights: ve.c(),
      zindexes: ct.c(),
      textShadows: ft.c(),
      boxShadows: pt.c(),
      borderRadiuses: mt.count(),
      animations: {
        durations: $.c(),
        timingFunctions: X.c()
      },
      prefixes: ut.c(),
      browserhacks: ze.c(),
      units: qe.count(),
      complexity: Ct,
      keywords: B.c()
    },
    __meta__: {
      parseTime: F - P,
      analyzeTime: Date.now() - F,
      total: Date.now() - l
    }
  };
}
function qt(i, t) {
  return i[0] === t[0] ? i[1] === t[1] ? t[2] - i[2] : t[1] - i[1] : t[0] - i[0];
}
export {
  xi as analyze,
  qt as compareSpecificity,
  D as hasVendorPrefix,
  Dt as isAccessibilitySelector,
  Zt as isMediaBrowserhack,
  pi as isPropertyHack,
  Jt as isSelectorPrefixed,
  Nt as isSupportsBrowserhack,
  Tt as isValuePrefixed,
  Ft as selectorComplexity
};
